#ifndef _PACKET_H
#define _PACKET_H

#include <netinet/udp.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
//#include "scanport_debug.h"

#define ATTACHED_DEVICES
//#define SCANPORT
//#define SCANPORT_DEBUG
#ifdef  SCANPORT_DEBUG
#define DPRINTF printf
#define FPRINTF fprintf
#else
#undef DPRINTF
#undef FPRINTF
#define DPRINTF
#define FPRINTF
#endif


#ifndef SCANPORT
#include "../boa.h"
#endif
#if 0
/* From rfc1002, 4.2.1.2 */
/* Question types. */
#define QUESTION_TYPE_NB_QUERY  0x20
#define QUESTION_TYPE_NB_STATUS 0x21

/* Question class */
#define QUESTION_CLASS_IN  0x1

/* Opcode definitions */
#define NMB_NAME_QUERY_OPCODE       0x0
#define NMB_NAME_REG_OPCODE         0x05 /* see rfc1002.txt 4.2.2,3,5,6,7,8 */
#define NMB_NAME_RELEASE_OPCODE     0x06 /* see rfc1002.txt 4.2.9,10,11 */
#define NMB_WACK_OPCODE             0x07 /* see rfc1002.txt 4.2.16 */
/* Ambiguity in rfc1002 about which of these is correct. */
/* WinNT uses 8 by default but can be made to use 9. */
#define NMB_NAME_REFRESH_OPCODE_8   0x08 /* see rfc1002.txt 4.2.4 */
#define NMB_NAME_REFRESH_OPCODE_9   0x09 /* see rfc1002.txt 4.2.4 */
#define NMB_NAME_MULTIHOMED_REG_OPCODE 0x0F /* Invented by Microsoft. */


typedef char pstring[1024];
typedef char fstring[128];
typedef int	ptrdiff_t;

#define False (0)
#define True (1)

//-- Byteorder.h
#define SVALMOD(buf,pos) (*(uint16 *)((char *)(buf) + (pos)))
#define SSVAL(buf,pos,val) SVALMOD(buf,pos)=((uint16)(val))
#define SREV(x) ((((x)&0xFF)<<8) | (((x)>>8)&0xFF))
#define RSSVAL(buf,pos,val) SSVAL(buf,pos,SREV(val))



#define SREV(x) ((((x)&0xFF)<<8) | (((x)>>8)&0xFF))
#define IREV(x) ((SREV(x)<<16) | (SREV((x)>>16)))
#define SIVALX(buf,pos,val) (SSVALX(buf,pos,val&0xFFFF),SSVALX(buf,pos+2,val>>16))
#define SIVAL(buf,pos,val) SIVALX((buf),(pos),((uint32)(val)))
#define RSIVAL(buf,pos,val) SIVAL(buf,pos,IREV(val))

#define SVAL(buf,pos) (PVAL(buf,pos)|PVAL(buf,(pos)+1)<<8)
#define IVAL(buf,pos) (SVAL(buf,pos)|SVAL(buf,(pos)+2)<<16)
//#define SSVALX(buf,pos,val) (CVAL(buf,pos)=(val)&0xFF,CVAL(buf,pos+1)=(val)>>8)
#define SIVALX(buf,pos,val) (SSVALX(buf,pos,val&0xFFFF),SSVALX(buf,pos+2,val>>16))
#define SVALS(buf,pos) ((int16)SVAL(buf,pos))
#define IVALS(buf,pos) ((int32)IVAL(buf,pos))
#define SSVAL(buf,pos,val) SSVALX((buf),(pos),((uint16)(val)))
#define SIVAL(buf,pos,val) SIVALX((buf),(pos),((uint32)(val)))
//#define SSVALS(buf,pos,val) SSVALX((buf),(pos),((int16)(val)))
#define SIVALS(buf,pos,val) SIVALX((buf),(pos),((int32)(val)))
 //-- Byteorder.h

#define pstrcpy(d,s) safe_strcpy((d),(s),sizeof(pstring)-1)
#define PTR_DIFF(p1,p2) ((ptrdiff_t)(((const char *)(p1)) - (const char *)(p2)))
#endif
/*
#define SCANPORT
//#define SCANPORT_DEBUG
#ifdef	SCANPORT_DEBUG
#define	DPRINTF	printf
#define FPRINTF fprintf
#else
//#undef DPRINTF
//#undef FPRINTF
#define DPRINTF
#define FPRINTF
#endif
*/

typedef	unsigned int uint16;
typedef int	BOOL;


#define MAX_DGRAM_SIZE (576) /* tcp/ip datagram limit is 576 bytes */
//#define MIN_DGRAM_SIZE 12

/* Opcode definitions */
//#define NMB_NAME_QUERY_OPCODE       0x0
#define NMB_PORT 137

#ifdef SCANPORT
typedef struct device_scaned
{
	u_char hostname[34];
	u_char scan_dst_hw[ETH_ALEN];
	u_char scan_dst_ip[4];
}__attribute__ ((packed)) DEVICE_SCANED;
DEVICE_SCANED device_scand[255];
#endif

/* A netbios name structure. -- natalie -- copy from smb.h*/
struct nmb_name {
  char	 name[34];
  //char         name[17];
  //char         scope[64];
  //unsigned short name_type;
};

/* A resource record. */
struct res_rec {
  struct nmb_name rr_name;
  unsigned short rr_type;
  unsigned short rr_class;
  unsigned short ttl;
  unsigned short ttl_2;
  unsigned short rdlength;
  unsigned char num_name;
  char rdata[MAX_DGRAM_SIZE];
};


/* An nmb packet. */
typedef struct  NM_FLAGS{
      unsigned short
      response:1,
      opcode:4,
      authoritative:1,
      trunc:1,
      recursion_desired:1,
      recursion_available:1,
      reserved:2,
      broadcast:1,
      rcode:4;
} nm_flags;

/*typedef struct  NM_FLAGS{
      unsigned short
      rcode:4,
      broadcast:1,
      reserved:2,
      recursion_available:1,
      recursion_desired:1,
      trunc:1,
      authoritative:1,
      opcode:4,
      response:1;
} nm_flags;*/

struct nmb_packet
{
  struct {
    unsigned short name_trn_id;
    unsigned short opcode;
    //nm_flags nmflags;	
    unsigned short qdcount;
    unsigned short ancount;
    unsigned short nscount;
    unsigned short arcount;
  } header;

  /*struct {
    struct nmb_name question_name;
    int question_type;
    int question_class;
  } question;*/

  struct res_rec answers;
  struct res_rec nsrecs;
  struct res_rec additional;
};



#ifdef ATTACHED_DEVICES
int netbios_packet(u_int32_t *source_ip, int source_port, u_int32_t *dest_ip, int dest_port, unsigned char *name);
#else
int netbios_packet(u_int32_t *source_ip, int source_port, u_int32_t *dest_ip, int dest_port, int cnt);
#endif
//BOOL initiate_name_query_packet_from_wins_server(u_int32_t *source_ip, u_int32_t *dest_ip, char *mac);
#endif
