/*
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <net/route.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <ctype.h>
#include <sys/file.h> //Brian+
#include <sys/types.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>

#include <dni_nvram.h>
#include <dni_netconf.h>
#include <dni_shutils.h>
#include "rc.h"
#include <pathnames.h>
//#include <clientApi.h>


#if 0
/*
* parse ifname to retrieve unit #
*/
int
ppp_ifunit(char *ifname)
{
	if (strncmp(ifname, "ppp", 3))
		return -1;
	if (!isdigit(ifname[3]))
		return -1;
	return atoi(&ifname[3]);
}
#endif

/*
 * Called when link comes up
 */
int
ipup_main(int argc, char **argv)
{
	FILE *fp;
	char *wan_ifname = safe_getenv("IFNAME");
	char *value;
	char buf[256];
	int unit;
	char tmp[100], prefix[] = "wanXXXXXXXXXX_";

	if ((unit = ppp_ifunit(wan_ifname)) < 0)
		return -1;
	
	snprintf(prefix, sizeof(prefix), "wan%d_", unit);

#if 0
	/* Touch connection file */
//	if (!(fp = fopen(strcat_r("/etc/ppp/link.", wan_ifname, tmp), "a"))) {
	if (!(fp = fopen(strcat_r(PPP_LINK_PATH, wan_ifname, tmp), "a"))) {
		perror(tmp);
		//printf("%s::fopen(/tmp/ppp/link.ppp0) fail\n");
		cprintf("%s::fopen(/tmp/ppp/link.ppp0) failed\n", __FUNCTION__);
		return errno;
	}
	fclose(fp);
#endif

	if ((value = getenv("IPLOCAL"))) {
		ifconfig(wan_ifname, IFUP,
			 value, "255.255.255.255");
		nvram_set(strcat_r(prefix, "ipaddr", tmp), value);
		nvram_set(strcat_r(prefix, "netmask", tmp), "255.255.255.255");
	}

        if ((value = getenv("IPREMOTE")))
		nvram_set(strcat_r(prefix, "gateway", tmp), value);

	//added by dvd.chen on 10/08/2004, because we might add a psudo_dns_server entry
	//in resolv.conf on ppp-dial-on-demand(pppoe OR pptp) mode.
	//with this entry the dnsproxy packet could possibily to trigger to connect.
	//so here we need to clear the psudo_entry first before we write in the real dns_server_entries in wan_up().
	{
		FILE *fp;
		//make sure it is ppp-dial-on-demand mode
		//modified by dvd.chen on 06/07/2005, just reset resolv.conf on ppp mode
		//if( (nvram_match("wan_proto","pppoe") && nvram_match("wan_pppoe_demand", "1")) 
		//	|| (nvram_match("wan_proto","pptp") && nvram_match("wan_pptp_idle_disconnect", "1")) )
		if( nvram_match("wan_proto","pppoe") || nvram_match("wan_proto","pptp") )
		//end of dvd.chen
		{
			//if (!(fp = fopen("/tmp/resolv.conf", "w"))) {
			if (!(fp = fopen("/var/resolv.conf", "w"))) {
				perror("/var/resolv.conf");
				return errno;
			}
			fprintf(fp, "nameserver 127.0.0.1\n");  //default entry, just add it
			fclose(fp);
		}
	}
	//end of dvd.chen

	//add wan_autodns check by dvd.chen, if wan_autodns is 0 ==> don't change wan0_dns, cause we gonna use manual setting
	if( atoi(nvram_get("wan_autodns"))==1 )
	{
		//setup dns from remote
		strcpy(buf, "");
		if (getenv("DNS1"))
			sprintf(buf, "%s", getenv("DNS1"));
		if (getenv("DNS2"))
			sprintf(buf + strlen(buf), "%s%s", strlen(buf) ? " " : "", getenv("DNS2"));
		nvram_set(strcat_r(prefix, "dns", tmp), buf);
	}

	cprintf("%s: calling wan_up(ifname:%s)\n",__FUNCTION__, wan_ifname);

	wan_up(wan_ifname);

	//cprintf("PPPoE is conneted!!!!\n"); 
	//strcpy(protocal, nvram_safe_get("wan_proto"));
	if (!strcmp(nvram_safe_get("wan_proto"), "pppoe"))
		//log_ppp_connect("WAN PPPoE is connected");//Brian+: write pppoe info into log file	
		log_WAN_connect("WAN PPPoE is connected");
	else if (!strcmp(nvram_safe_get("wan_proto"), "pptp"))
		//log_ppp_connect("WAN PPTP is connected");//Brian+: write pptp info into log file   
		log_WAN_connect("WAN PPTP is connected");

	dprintf("done\n");
	return 0;
}
/*
 * Called when link goes down
 */
int
ipdown_main(int argc, char **argv)
{
	char *wan_ifname = safe_getenv("IFNAME");
	int unit;
	char tmp[100], prefix[] = "wanXXXXXXXXXX_";
	//char protocal[50];
	//int i;
	char lock_file_path[32];
	int is_ssl_vpn_ppp=0;
	char *str_ssl_ip_s;

	if ((unit = ppp_ifunit(wan_ifname)) < 0)
		return -1;
	
	snprintf(prefix, sizeof(prefix), "wan%d_", unit);

	cprintf("%s: calling wan_down(ifname:%s)\n",__FUNCTION__, wan_ifname);

	wan_down(wan_ifname);

	//unlink(strcat_r("/tmp/ppp/link.", wan_ifname, tmp));
	unlink(strcat_r(PPP_LINK_PATH, wan_ifname, tmp));

	preset_wan_routes(wan_ifname);
	//cprintf("PPPoE is disconneted!!!!\n");
	if (!strcmp(nvram_safe_get("wan_proto"), "pppoe"))
		//log_ppp_connect("WAN PPPoE is disconnected");//Brian+: write pppoe info into log file   
		log_WAN_connect("WAN PPPoE is disconnected");
	else if (!strcmp(nvram_safe_get("wan_proto"), "pptp"))
		//log_ppp_connect("WAN PPTP is disconnected");//Brian+: write pptp info into log file   
		log_WAN_connect("WAN PPTP is disconnected");
	return 0;
}
